;$7700-  
; 

	device zxspectrum128
        ORG #6000
begin
 di
;CRAM[0..15] = 
;open FMAddr access from 0x8000
 ld bc, 0x15AF
 ld a, 0x18
 out (c), a

;load CRAM
 ld de,$8000
 ld hl,pal0b
 ld bc,pal0e-pal0b
 ldir
;.: gggBBbbb
;.: 0RRrrrGG

FMAddr     EQU #15AF
;close FMAddr
 ld bc, 0x15AF
 xor a
 out (c), a
;-------------------------------------------------------
;PalSel = %00 //   0   0
PalSel          EQU	#07AF
 ld bc,PalSel
 ld a,%00000000
 out (c),a



;------------------------------------------------------
; ld bc,$18AF;T1GPage = $12 //    0   $10
; ld a,$12
; out (c),a
; ld bc,Page3
; out (c),a
; ld hl,$C000,de,$C001,bc,16384,(hl),0:ldir


;Page3 = 16
Page3           EQU	#13AF
 ld bc,Page3
 ld a,$10
 out (c),a

;#000..#C003
;#C100..#C103
;#C700..#C703 =   (88)   4   

; ld hl,0,($c000),hl
 ld hl,$C000,de,$C001,bc,16384,(hl),l:ldir

 ld de,$c000
 ld hl,tilebitmap
 ld a,8
copytile:push de
 ld bc,32*4:ldir
 pop de:inc d
 dec a:jr nz,copytile

 ld bc,$17AF;T0GPage = 16 //    0   16
 ld a,$10
 out (c),a
;
;Page3 = 17
 ld bc,Page3
 ld a,$11
 out (c),a

;;;;; tilemap
;#000 = %00000000
;#C001 = %00000000 //  0   0

;;; ,   - 1 
 ld hl,0,($c000),hl
 ld hl,$C000,de,$C002,bc,16384-2:ldir

; ld hl,$C000+18*2+8*2
; ld de,0
;fill_tilemap:
; ld (hl),e:inc hl
; ld (hl),d:inc hl
; inc e
; ld a,e:cp 20;bit 7,e
; jr nz, fill_tilemap

;TMPage = 17
 ld bc,$16AF
 ld a,$11
 out (c),a

;------------------------------turn video on
VID_16C         equ $01
VID_256C        equ $02
VID_360X288     equ $C0
PLANE0_MODE		equ VID_256C
RASTER_SIZE		equ VID_360X288

VID_NOGFX       equ $20
VConfig         equ $00AF
 LD	BC,VConfig    ;  : %01-360x288, %010-256 
 LD	A,VID_NOGFX | RASTER_SIZE
 OUT	(C),A

;TSConfig = %00100100 //   0,    0 (    - ), .. 0-4095(12)  
TSCONFIG        equ $06AF
TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80
;	; ... and tile planes
 ld bc,TSCONFIG;;$06AF
 ld a,%01101100;?TSU_T0EN | TSU_T1EN | TSU_T0ZEN | TSU_T1ZEN

 ld a,%00100100;?TSU_T0EN | TSU_T0ZEN
 out (c),a


 xor a:out ($FE),a
 ld hl,$8000,de,$8001,bc,6144,(hl),0:ldir
 ld bc,767,(hl),0:ldir
; ld hl,$8800,de,$5801,ld bc,768,(hl),l:ldir

;- 
 ld ix,$8800+1;;  
 ld de,32
 ld b,23
st_wid equ 14; 
stlp1:
stcol equ 9;$FF
 ld (ix),stcol
 ld (ix+1+st_wid),stcol
 add ix,de
 djnz stlp1
 
 ld b,16
stlp2: ld (ix),stcol:inc ix:djnz stlp2
;---------------- --------------
 ld hl,$8800+17
 ld b,8
hsc_lp:ld (hl),7:inc l:djnz hsc_lp


 ld hl,$8800,de,stakan,bc,768:ldir
;------ init figure --------------
init_figure:
i1:call random
 and 7:cp 7:jr z,i1
 inc a

; add a,a
; add a,a
; add a,a

 ld (fig_color+1),a


i2:call random
 and 7:cp 7:jr z,i2
 ld (figure_n+1),a

 ld a,0,(downf+1),a
 ld a,0,(rotate+1),a
;; ld a,0,(keyf+1),a
 
 ld de,$FC01+4,(fig_xy+1),de
;---------------------------------
game_lp:
; ld hl,9999
; call printhl
; call addn2sco
 call showscore

 ld a,15
key: exa:ei:halt
;;keyf: ld a,0
;; or a:call z,keytest
 call keytest
;downf:ld a,0:or a:jr nz,quit_delay;;;;  
 exa:dec a;:jr nz,key

;;quit_delay:
;; xor a:ld (keyf+1),a


 ld de,$8800,hl,stakan,bc,768:ldir

rotate:ld l,0
 ld h,0
 add hl,hl
 push hl

figure_n:ld l,0+6
 ld h,0
 add hl,hl
 ld de,figbase
 add hl,de
 ld e,(hl):inc hl:ld d,(hl)
 pop hl
 add hl,de;hl=address
 
 push hl
 
fig_xy: ld de,$0001*0;;;;;;;;;;;$5801;DE=X.Y
 ld h,0,l,d,d,h
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,de
 ld de,$8800
 add hl,de

 pop de
 ld a,(de)
 call fig_line
 call fig_line
 inc de

 ld a,(de)
 call fig_line
 call fig_line
;----------------------------- 
 ld hl,$8800
 ld de,$C000
 ld ixl,24
to_tile1:
 push de,hl

 dup 17
 ld a,(hl):inc hl
 ld (de),a:inc de
 xor a
 ld (de),a:inc de
edup

 pop hl,de
 inc d
 ld bc,32
 add hl,bc
 
 dec ixl:jp nz,to_tile1
 
 
 
downf:ld a,0:or a:jr nz,skip_delay;;;;  
cnt:ld hl,0
 ld de,16
 add hl,de
 ld (cnt+1),hl
 ld a,h:or a:jp z,game_lp

skip_delay:
 ld hl,0,(cnt+1),hl

;---  
 ld de,(fig_xy+1)
 inc d
 call det_col
;; out ($FE),a
 jp nz,stuck;game_lp
 ld (fig_xy+1),de
 jp game_lp
;-------------------
stuck:
 ld a,d
 cp 2:jr nc,check_lines
 
 ld hl,$D000+6
 ld de,gameover
 ld b,9
go_lp:
 ld a,(de):inc de
 ld (hl),a:inc hl
 ld (hl),0:inc hl
 djnz go_lp
 jr $
; or a:jp p,check_lines;game_lp;   
;stp:ld a,r:out ($FE),a:jr stp;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;GAME OVER,  hiscore!
;-------------------    
check_lines:
 ld ix,$8B02-2*32
rem_line1:
 push ix:pop hl
 ld bc,st_wid;14
check:
 ld a,(hl):or a:jr z,nextpos
 inc b
nextpos:
 inc l:dec c:jr nz,check
 ld a,b:cp st_wid:jr nz,no_remove_line;14
;--------------------  
 ld hl,14
 call printhl
 call addn2sco

 push ix

rem_line3:
 ld b,st_wid
 push ix
rem_line2:
 ld a,(ix-32),(ix),a
 inc ix:djnz rem_line2
 pop ix
 ld de,0-32:add ix,de
 ld a,ixh:cp $87:jr nz,rem_line3

 pop ix
 ei:halt
 jp rem_line1
no_remove_line:
 ld de,0-32:add ix,de
 ld a,ixh:cp $87:jr nz,rem_line1


;;-------------------
; ld de,(fig_xy+1)
; ld a,d
; or a:jp p,may_game;game_lp;   

;stp:ld a,r:out ($FE),a:jr stp
may_game:
 ld hl,$8800,de,stakan,bc,768:ldir
 jp init_figure
;------------------------kboard
keytest:
 ld a,(downf+1):or a:ret nz
 xor a:in a,($FE)
 cpl:and 31:ret z
 
;; ld (keyf+1),a

;----------up pressed
 ld a,$EF:in a,($FE)
 and 8:jr nz,next_k1
 ld a,(rotate+1)
 ld (prev_rot+1),a
 inc a:and 3
 ld (rotate+1),a
 ld de,(fig_xy+1)
 call det_col
;; out ($FE),a
 jp z,wk;  
prev_rot:ld a,0
 ld (rotate+1),a

wk:; ld a,(downf+1):or a:ret nz

; ld bc,65000
wk1:
; dec bc:ld a,b:or c:ret z
 xor a:in a,($FE)
 cpl:and $1F:jr nz,wk1

 ret
next_k1:
 ld a,#EF;right
 in a,(#FE)
 and 4: jr nz,next_k2
 ld de,(fig_xy+1)
 inc e
 call det_col
;; out ($FE),a
 jp nz,wk
 ld (fig_xy+1),de
 jp wk
next_k2:
 ld a,#F7;left
 in a,(#FE)
 and 16:jr nz,next_k3

 ld de,(fig_xy+1)
 dec e

 call det_col
;; out ($FE),a
 jp nz,wk
 ld (fig_xy+1),de
 jp wk

next_k3:
 ld a,#EF;down
 in a,(#FE)
 and 16:ret nz
 ld a,1,(downf+1),a

 ld hl,4
 call printhl
 call addn2sco

 jp wk;ret
;---------------------------------
fig_line:
 ld b,4
fig_line2:
 add a,a;or a:rra
 ld c,0
 jr nc,skip_fig

fig_color: ld(hl),7

skip_fig:
 inc l
 djnz fig_line2
 ld bc,32-4:add hl,bc
 ret

random:
R1:LD C,$15+3
R2:LD A,#70
 ADD A,C:LD C,A
 LD (R1+1),A
R3:LD A,#FD
 SUB C:LD C,A,(R2+1),A
 RRCA:LD (R3+1),A
 LD A,C
 RET
;------ detect collision -------------
det_col:;A=0 if possible move, A=1 if no more move
;DE=X.Y figure
 push de
 ld h,0,l,d,d,h
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,de
 ld de,stakan;;$8800
 add hl,de
 push hl
;-----------------determine figure
 ld a,(rotate+1)
 ld h,0,l,a
 add hl,hl
 push hl

 ld a,(figure_n+1)
 ld h,0,l,a
 add hl,hl
 ld de,figbase
 add hl,de
 ld e,(hl):inc hl:ld d,(hl)
 pop hl
 add hl,de;hl=address figure
 pop de;de->stakan

 ld c,(hl)
 call det_fig1:jp nz,collision_fnd
 call det_fig1:jp nz,collision_fnd

 inc hl
 ld c,(hl)
 call det_fig1:jp nz,collision_fnd
 call det_fig1:jp nz,collision_fnd
;-no colission
 pop de
 xor a:ret

det_fig1:
 ld b,4
det_fig2:
 or a:rl c
 jr nc,no_fig
 ld a,(de):or a:ret nz
no_fig:
 inc de
 djnz det_fig2
 ld a,e:add a,32-4:ld e,a
 ld a,d:adc a,0:ld d,a
 xor a:ret
;-----
collision_fnd:
 pop de
 ld a,1
 or a
 ret
gameover: db $14,$15,$16,$17,0,$18,$19,$17,$1A
;---------------------hiscore routines
;---------print number in HL to numbuf------
printhl:
 exx
 ld hl,numbuf+3;score+3;
 exx
 LD            DE ,10000
 CALL          L8181
 LD            DE ,1000
 CALL          L8181
 LD            DE ,100
 CALL          L8181
 LD            DE ,10
 CALL          L8181
 LD            A,L
 jr putdig
; exx:ld (hl),a:inc hl:exx
; ret
L8181: LD            C ,$00
L8183: INC           C
 OR            A
 SBC           HL ,DE
 JR            NC ,L8183

 ADD           HL ,DE
 DEC           C
 LD            A ,C
putdig:
 exx:ld (hl),a:inc hl:exx
 ret
;------------add digit to score-------------
addn2sco:
 ld hl,score+7
 ld de,numbuf+7
 ld b,8
addlp:
 ld a,(de):dec de
 add a,(hl):cp 10
 jr c,nextpo
 dec hl
 inc (hl)
 inc hl
 sub 10;xor a
nextpo:
 ld (hl),a:dec hl:djnz addlp
 ret
;----------------------score----------------
showscore:

 ld de,$C000+18*2
 ld ix,score
 ld b,8
slp:ld a,(ix):inc ix
 add a,$0A
 ld (de),a:inc e,e
 djnz slp
 ret


;
; ld de,$4000+17
; ld ix,score
; ld b,8
;slp:ld a,(ix):inc ix;:or a:ret z
; add a,#30
; ld l,a,h,0
; add hl,hl
; add hl,hl
; add hl,hl
; ld a,h:add a,#3C:ld h,a
; push de
; dup 8
; ld a,(hl),(de),a:inc hl,d
;edup
; pop de:inc e:djnz slp
 ;ret
score: db 0,0,0,0,0,0,0,0
numbuf:db 0,0,0,0,0,0,0,0

;-------------------------tetris figures---------------------------
figbase:
 dw fig_o
 dw fig_i
 dw fig_s
 dw fig_z
 dw fig_l
 dw fig_j
 dw fig_t
 
fig_o:
 db %00000110,%01100000;phase 0----------check
 db %00000110,%01100000;phase 1
 db %00000110,%01100000;phase 2
 db %00000110,%01100000;phase 3
 
fig_i:
 db %00100010,%00100010;+
 db %00001111,%00000000
 db %00100010,%00100010
 db %00001111,%00000000
; db %00100010,%00100010

fig_s:
 db %00000011,%01100000;+
 db %00100011,%00010000
 db %00000011,%01100000
 db %00100011,%00010000

fig_z:
 db %00000110,%00110000;+
 db %00010011,%00100000
 db %00000110,%00110000
 db %00010011,%00100000

fig_l:
 db %00000111,%01000000;check
 db %00100010,%00110000
 db %00010111,$00000000
 db %01100010,%00100000

fig_j:
 db %00000111,%00010000;+
 db %00110010,%00100000
 db %01000111,%00000000
 db %00100010,%01100000

fig_t:
 db %00000111,%00100000
 db %00100011,%00100000
 db %00100111,%00000000
 db %00100110,%00100000
 
stakan:
 include "tileset0.inc"

end
	display /d,end-begin
	savesna "!tetr.sna",begin

	savebin "spg\tetris.bin",begin,end-begin

 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FE0

 ld de,(#5CF4)
 ld hl, #6000
 sectors begin,end
 call #3d13

 jp $6000


 db "yo,lamer!"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

    EMPTYTRD "tetris.trd" ;create empty TRD image
	SAVETRD "tetris.trd", "boot.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "tetris.trd","tetris.C",begin,end-begin
